﻿namespace ProjectFighterJet.Entities
{
    public class EntityFighterJet : EntityJet
    {

        /// <summary>
        /// Дополнительный цвет (для опциональных элементов)
        /// </summary>
        public Color AdditionalColor { get; private set; }
        /// <summary>
        /// Признак (опция) наличия ракет
        /// </summary>
        public bool Rockets { get; private set; }
        /// <summary>
        /// Признак (опция) наличия топливного бака   
        /// </summary>
        public bool Fuel { get; private set; }
        /// <summary>
        /// Признак (опция) наличия двигателя
        /// </summary>
        public bool Engines { get; private set; }

        /// <summary>
        /// Инициализация полей объекта-класса спортивного автомобиля
        /// </summary>
        /// <param name="speed">Скорость</param>
        /// <param name="weight">Вес истрибителя</param>
        /// <param name="bodyColor">Основной цвет</param>
        /// <param name="additionalColor">Дополнительный цвет</param>
        /// <param name="rockets">Признак наличия ракет</param>
        /// <param name="fuel">Признак наличия топливного бака</param>
        /// <param name="engines">Признак наличия двигателей</param>
        public EntityFighterJet (int speed, double weight, Color bodyColor, Color additionalColor, bool rockets, bool fuel, bool engines) : base(speed, weight, bodyColor)
        {

            AdditionalColor = additionalColor;
            Rockets = rockets;
            Fuel = fuel;
            Engines = engines;
        }
    }

}

